#ifndef _MODBUS_MSXE370X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE370X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Wed Feb 24 09:58:14 2016*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MX370X__GETNUMBEROFCHANNELS=100,
MX370X__GETNUMBEROFCHANNELSEX=1000,
MX370X__TRANSDUCERGETAUTOREFRESHVALUES=101,
MX370X__TRANSDUCERGETAUTOREFRESHVALUESEX=1050,
MX370X__TRANSDUCERGETNBROFTYPE=102,
MX370X__TRANSDUCERGETNBROFTYPEEX=1594,
MX370X__GETTRANSDUCERDATABASECURSOR=103,
MX370X__GETTRANSDUCERDATABASECURSOREX=1598,
MX370X__TRANSDUCERGETTYPEINFORMATION=104,
MX370X__TRANSDUCERGETTYPEINFORMATIONEX=1602,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MX370x__getNumberOfChannels_parameters_t
{
	uint32_t ChannelNumber;
 } __PACKED;

struct MX370x__getNumberOfChannelsEx_parameters_t
{
	uint32_t ChannelNumber;
 } __PACKED;

struct MX370x__TransducerGetAutoRefreshValues_parameters_t
{
	uint32_t Value[17];
 } __PACKED;

struct MX370x__TransducerGetAutoRefreshValuesEx_parameters_t
{
	uint32_t Value[17];
 } __PACKED;

struct MX370x__TransducerGetNbrOfType_parameters_t
{
	uint32_t NumberOfTransducerTypes;
 } __PACKED;

struct MX370x__TransducerGetNbrOfTypeEx_parameters_t
{
	uint32_t NumberOfTransducerTypes;
 } __PACKED;

struct MX370x__GetTransducerDatabaseCursor_parameters_t
{
	uint32_t TransducerDatabaseCursor;
 } __PACKED;

struct MX370x__GetTransducerDatabaseCursorEx_parameters_t
{
	uint32_t TransducerDatabaseCursor;
 } __PACKED;

struct MX370x__TransducerGetTypeInformation_parameters_t
{
	uint32_t SelectionIndex;
	uint8_t Name[100];
	uint8_t CalibrationStatus;
	uint32_t Type;
	uint32_t Frequency;
	uint32_t Impedance;
	float NominalVoltage;
	float Sensibility;
	float Range;
 } __PACKED;

struct MX370x__TransducerGetTypeInformationEx_parameters_t
{
	uint32_t SelectionIndex;
	uint8_t Name[100];
	uint8_t CalibrationStatus;
	uint32_t Type;
	uint32_t Frequency;
	uint32_t Impedance;
	float NominalVoltage;
	float Sensibility;
	float Range;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Return the number of transducer channels on the module (4,8 or 16)</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <ul>@param[out]<b><VAR>ChannelNumber:</VAR></b> Number of channels</p></ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__getNumberOfChannels(struct modbus * modbus,struct MX370x__getNumberOfChannels_parameters_t * Response);



/** <p>Return the number of transducer channels on the module (4,8 or 16)</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <ul>@param[out]<b><VAR>ChannelNumber:</VAR></b> Number of channels</p></ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__getNumberOfChannelsEx(struct modbus * modbus,struct MX370x__getNumberOfChannelsEx_parameters_t * Response);



/** <p>This function get the auto refresh counter value an the channels values</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>@param[out]<b><VAR>Value: </VAR></b> Array that contain the counter and channels values (raw or converted, depending of the configuration)\n
* <ul><li> Values [0]: Auto refresh counter value \n
* <li> Values [1]: Channel 0 value \n
* <li> ... \n
* <li> Values [16]: Channel 15 value \n
* </ul></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0 : success \n
* <li> -100 : GetAutoRefreshAllValues kernel function error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetAutoRefreshValues(struct modbus * modbus,struct MX370x__TransducerGetAutoRefreshValues_parameters_t * Response);



/** <p>This function get the auto refresh counter value an the channels values</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>@param[out]<b><VAR>Value: </VAR></b> Array that contain the counter and channels values (raw or converted, depending of the configuration)\n
* <ul><li> Values [0]: Auto refresh counter value \n
* <li> Values [1]: Channel 0 value \n
* <li> ... \n
* <li> Values [16]: Channel 15 value \n
* </ul></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0 : success \n
* <li> -100 : GetAutoRefreshAllValues kernel function error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetAutoRefreshValuesEx(struct modbus * modbus,struct MX370x__TransducerGetAutoRefreshValuesEx_parameters_t * Response);



/** <p>Returns the number of transducer types currently defined in the database.</p>
*
* <p><b>Parameters:</b></p>
*
* <p>@param[in] <b><VAR>NumberOfTransducerTypes:</VAR></b> number of transducer types currently defined.</p>

* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetNbrOfType(struct modbus * modbus,struct MX370x__TransducerGetNbrOfType_parameters_t * Response);



/** <p>Returns the number of transducer types currently defined in the database.</p>
*
* <p><b>Parameters:</b></p>
*
* <p>@param[in] <b><VAR>NumberOfTransducerTypes:</VAR></b> number of transducer types currently defined.</p>

* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetNbrOfTypeEx(struct modbus * modbus,struct MX370x__TransducerGetNbrOfTypeEx_parameters_t * Response);



/** <p>Returns the current cursor of the transducer database.</p>
*
* <p><b>Parameters:</b></p>
*
* <p>@param[in] <b><VAR>TransducerDatabaseCursor:</VAR></b> Current cursor. This is an integer from 0 .. (NumberOfTransducerTypes-1) </p>
*
* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__GetTransducerDatabaseCursor(struct modbus * modbus,struct MX370x__GetTransducerDatabaseCursor_parameters_t * Response);



/** <p>Returns the current cursor of the transducer database.</p>
*
* <p><b>Parameters:</b></p>
*
* <p>@param[in] <b><VAR>TransducerDatabaseCursor:</VAR></b> Current cursor. This is an integer from 0 .. (NumberOfTransducerTypes-1) </p>
*
* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__GetTransducerDatabaseCursorEx(struct modbus * modbus,struct MX370x__GetTransducerDatabaseCursorEx_parameters_t * Response);



/** <p>Returns the information stored in the database about the type selected by the current TransducerDatabaseCursor.</p>
*
* <p><b>Parameters:</b></p>
*
* <b> <VAR>SelectionIndex :</VAR> </b> Identifier. Value to use for the transducer type selection in the other SOAP functions. \n
* <b> <VAR>Name :</VAR> </b> Name of the transducer type \n
* <b> <VAR>CalibrationStatus :</VAR> </b> Calibration status
*                                    \li 0 : Transducer type is not calibrated \n
*                                    \li 1 : Transducer type is calibrated \n
*
* <b> <VAR>Type :</VAR> </b> Type (0: HB 1: LVDT 2:Knaebel 3:HB-Mahr 4:LVDT-Mahr)
*
* <b> <VAR>Frequency :</VAR> </b> Frequency (Hz) \n
* <b> <VAR>Impedance :</VAR> </b> Impedance (Ohm) \n
* <b> <VAR>Veff :</VAR> </b> Nominal voltage (Vrms) \n
* <b> <VAR>Sensibility :</VAR> </b> Sensibility (mv/V/mm)  \n
* <b> <VAR>Range :</VAR> </b> Range (mm) \n
*
* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetTypeInformation(struct modbus * modbus,struct MX370x__TransducerGetTypeInformation_parameters_t * Response);



/** <p>Returns the information stored in the database about the type selected by the current TransducerDatabaseCursor.</p>
*
* <p><b>Parameters:</b></p>
*
* <b> <VAR>SelectionIndex :</VAR> </b> Identifier. Value to use for the transducer type selection in the other SOAP functions. \n
* <b> <VAR>Name :</VAR> </b> Name of the transducer type \n
* <b> <VAR>CalibrationStatus :</VAR> </b> Calibration status
*                                    \li 0 : Transducer type is not calibrated \n
*                                    \li 1 : Transducer type is calibrated \n
*
* <b> <VAR>Type :</VAR> </b> Type (0: HB 1: LVDT 2:Knaebel 3:HB-Mahr 4:LVDT-Mahr)
*
* <b> <VAR>Frequency :</VAR> </b> Frequency (Hz) \n
* <b> <VAR>Impedance :</VAR> </b> Impedance (Ohm) \n
* <b> <VAR>Veff :</VAR> </b> Nominal voltage (Vrms) \n
* <b> <VAR>Sensibility :</VAR> </b> Sensibility (mv/V/mm)  \n
* <b> <VAR>Range :</VAR> </b> Range (mm) \n
*
* <p><b> Returns:</b></p>
* 
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*  <li> 0 : success \n
*  <li> otherwise : internal error\n
* </ul></p></ul>
*/



/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MX370x__TransducerGetTypeInformationEx(struct modbus * modbus,struct MX370x__TransducerGetTypeInformationEx_parameters_t * Response);


/* Symbolic names for register */
enum {
MX370X__TRANSDUCERINITANDSTARTAUTOREFRESH=1,
MX370X__TRANSDUCERINITANDSTARTAUTOREFRESHEX=1200,
MX370X__TRANSDUCERSTOPANDRELEASEAUTOREFRESH=2,
MX370X__TRANSDUCERSTOPANDRELEASEAUTOREFRESHEX=1250,
MX370X__TRANSDUCERINITANDSTARTSEQUENCE=3,
MX370X__TRANSDUCERINITANDSTARTSEQUENCEEX=1300,
MX370X__TRANSDUCERSTOPANDRELEASESEQUENCE=4,
MX370X__TRANSDUCERSTOPANDRELEASESEQUENCEEX=1350,
MX370X__SETTRANSDUCERDATABASECURSOR=5,
MX370X__SETTRANSDUCERDATABASECURSOREX=1354,
MX370X__TRANSDUCERSETOFFSET=6,
MX370X__TRANSDUCERSETOFFSETEX=1356,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MX370x__TransducerInitAndStartAutoRefresh_parameters_t
{
	uint32_t TransducerSelection;
	uint32_t ChannelMask;
	uint32_t AverageMode;
	uint32_t AverageValue;
	uint32_t DivisionFactor;
	uint32_t TriggerAction;
	uint16_t HardwareTriggerCount;
	uint16_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;
 } __PACKED;

struct MX370x__TransducerInitAndStartAutoRefreshEx_parameters_t
{
	uint32_t TransducerSelection;
	uint32_t ChannelMask;
	uint32_t AverageMode;
	uint32_t AverageValue;
	uint32_t DivisionFactor;
	uint32_t TriggerAction;
	uint16_t HardwareTriggerCount;
	uint16_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;
 } __PACKED;

struct MX370x__TransducerStopAndReleaseAutoRefresh_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MX370x__TransducerStopAndReleaseAutoRefreshEx_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MX370x__TransducerInitAndStartSequence_parameters_t
{
	uint32_t TransducerSelection;
	uint32_t NbrOfChannel;
	uint32_t ChannelList[16];
	uint32_t DivisionFactor;
	uint32_t NbrOfSequence;
	uint32_t NbrMaxSequenceToTransfer;
	uint32_t DelayMode;
	uint32_t DelayTimeUnit;
	uint32_t DelayValue;
	uint32_t TriggerAction;
	uint32_t HardwareTriggerCount;
	uint32_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;
 } __PACKED;

struct MX370x__TransducerInitAndStartSequenceEx_parameters_t
{
	uint32_t TransducerSelection;
	uint32_t NbrOfChannel;
	uint32_t ChannelList[16];
	uint32_t DivisionFactor;
	uint32_t NbrOfSequence;
	uint32_t NbrMaxSequenceToTransfer;
	uint32_t DelayMode;
	uint32_t DelayTimeUnit;
	uint32_t DelayValue;
	uint32_t TriggerAction;
	uint32_t HardwareTriggerCount;
	uint32_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;
 } __PACKED;

struct MX370x__TransducerStopAndReleaseSequence_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MX370x__TransducerStopAndReleaseSequenceEx_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MX370x__SetTransducerDatabaseCursor_parameters_t
{
	uint32_t TransducerDatabaseCursor;
 } __PACKED;

struct MX370x__SetTransducerDatabaseCursorEx_parameters_t
{
	uint32_t TransducerDatabaseCursor;
 } __PACKED;

struct MX370x__TransducerSetOffset_parameters_t
{
	float fOffsetArrayPointer[16];
 } __PACKED;

struct MX370x__TransducerSetOffsetEx_parameters_t
{
	float fOffsetArrayPointer[16];
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Initialise and start the transducer auto refresh acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <p>@param[in] <b><VAR>TransducerSelection:</VAR></b> Transducer type selection</p>
* <p>@param[in] <b><VAR>ChannelMask:</VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel)</p>
* <p>@param[in] <b><VAR>AverageMode:</VAR></b> Set the average mode : \n
*	<ul>
*                              <li> 0: not used \n
*                              <li> 1: average per Sequence \n
*                              <li> 2: average per channel
*   </ul></p>
* <p>@param[in] <b>AverageValue:</b> Set the average value (only used, when average is used) \n
*	<ul>
*                             <li> 0: average not used \n
*                             <li> max value: 255
*   </ul></p>
* <p>@param[in] <b>DivisionFactor:</b> Division factor (min : 5, max 255)</p>
* <p>@param[in]  <b>TriggerAction:</b> Trigger action : \n
*				 <ul><li><b> <VAR>Hardware Trigger Start D0 - D7 </VAR> </b>\n
*				 	Bit 3,2,1,0 : Define the trigger mode \n
*				 	<ul><li> 0000 : Trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*					<ul>
*				 	Bit 7,6 : define the active front (Only if hardware trigger selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger selected) \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Synchronisation Trigger Start : D8-D15 </VAR> </b>\n
*				 	Bit 11,10,9,8 : Define the trigger mode \n
*				 	<ul><li> 0000 : trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Hardware Trigger Stop D16 - D19 </VAR> </b>\n
* 					The hardware trigger stop can only be activated when :\n
* 					<ul><li> The hardware trigger start is not used.\n
*  					<li> The hardware trigger start is used in one shot mode.\n</ul></ul><br>
*
* 					<ul>The stop of the acquisition is really do at the end of a sequence acquisition(to avoid that the acquisition is stop in the middle of a sequence).\n </ul><br>
*                   <ul>
*				 	Bit 16 : Define the trigger stop is enable or not \n<ul>
*				 	<li> 0 : Stop trigger disabled \n
*				 	<li> 1 : Stop trigger enabled.\n</ul></ul><br>
*
*                   <ul>
*				 	Bit 18,17 : define the active front (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger stop selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger stop selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger stop selected) \n</ul></ul><br>
*
*                   <ul>
*				 	Bit 19 : define if the hardware trigger stop use the ulHardwareTriggerCount (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 0 : ulHardwareTriggerCount not used : First hardware trigger stop will stop the acquisition \n
*				 	<li> 1 : ulHardwareTriggerCount is used : The ulHardwareTriggerCount hardware trigger will stop the acquisition\n</ul></ul><br>
*
*					</p>
*
* <p>@param[in] <b>HardwareTriggerCount:</b> Define the number of trigger events before the action occur \n<ul>
*										<li>0 or 1: all trigger event start the action \n
*										<li>max value: 65535</ul></p>
* <p>@param[in] <b>HardwareTriggerFilterTime:</b> filter time for the hardware trigger \n<ul>
*										<li>in multiplier from 250 ns step \n
*										<li>max value: 65535</ul></p>
* <p>@param[in] <b>ByTriggerNbrOfSeqToAcquire:</b> define the number of sequences to acquire by each trigger event</p>
* <p>@param[in] <b>Option1:</b> Data format option \n<ul>
*                        <li>D0: Time stamp information \n<ul>
*                        <li> 0: no time stamp information \n
*                        <li> 1: time stamp information \n</ul><br></ul>
*
*                        <ul><li>D1: Data format \n<ul>
*                        <li> 0: Digital value \n
*                        <li> 1: Analog value (in mm) \n</ul></ul><br>
*
*                        <ul><li>D2: invert value \n<ul>
*                        <li> 0: don't invert the channel value \n
*                        <li> 1: invert the channel value (-2 mm -> + 2mm) \n</ul></ul></p>
*
* <p>@param[in] <b>Option2:</b> Reserved</p>
* <p>@param[in] <b>Option3:</b> Reserved</p>
* <p>@param[in] <b>Option4:</b> Reserved</p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                            <li>  0: success \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Transducer selection error \n
*                            <li> -3: Channel mask error : can not be null \n
*                            <li> -4: Channel mask error \n
*                            <li> -5: Average mode error \n
*                            <li> -6: Average value error \n
*                            <li> -7: Division factor error \n
*                            <li> -8: Incorrect value for Hardware Trigger Mode \n
*                            <li> -9: Incorrect value for Hardware Trigger front \n
*                            <li> -10: Incorrect value for Synchro Trigger Mode \n
*                            <li> -11: Incorrect value for Hardware Trigger count \n
*                            <li> -12: Incorrect value for Hardware Trigger filter time \n
*                            <li> -13: Incorrect value for "trigger number of sequences to acquire"\n
*                            <li> -14: Wrong data format parameter (ulOption1) \n
* 							 <li> -15: A value for Hardware Trigger front was defined but Hardware Trigger Mode is not set \n
* 							 <li> -16: Cannot use both triggers at the same time \n
*						     <li> -17: Incorrect value for the hardware trigger stop front \n
*                            <li> -18: Hardware trigger stop can not be used by this configuration of hardware trigger start\n
*
*                            <li> -100: TransducerInit kernel function error \n
*                            <li> -101: InitConvertTimeDivisionFactor kernel function error \n
*                            <li> -102: SetAutoRefreshAverageValue kernel function error \n
*                            <li> -103: InitDigitalInputFilter kernel function error \n
*                            <li> -104: InitEnableDisableHardwareTrigger kernel function error \n
*                            <li> -105: SynchroTrigger Init/Enable/Disable kernel function error \n
*                            <li> -106: SetTriggerSequenceCount kernel function error \n
*                            <li> -107: StartAutoRefresh kernel function error \n
*
*</ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerInitAndStartAutoRefresh(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerSelection;
	uint32_t ChannelMask;
	uint32_t AverageMode;
	uint32_t AverageValue;
	uint32_t DivisionFactor;
	uint32_t TriggerAction;
	uint16_t HardwareTriggerCount;
	uint16_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerInitAndStartAutoRefresh(modbus,TransducerSelection,ChannelMask,AverageMode,AverageValue,DivisionFactor,TriggerAction,HardwareTriggerCount,HardwareTriggerFilterTime,ByTriggerNbrOfSeqToAcquire,Option1,Option2,Option3,Option4,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerInitAndStartAutoRefresh");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerInitAndStartAutoRefresh\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerInitAndStartAutoRefresh()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerInitAndStartAutoRefresh OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerInitAndStartAutoRefresh(struct modbus * modbus,
	uint32_t TransducerSelection,
	uint32_t ChannelMask,
	uint32_t AverageMode,
	uint32_t AverageValue,
	uint32_t DivisionFactor,
	uint32_t TriggerAction,
	uint16_t HardwareTriggerCount,
	uint16_t HardwareTriggerFilterTime,
	uint32_t ByTriggerNbrOfSeqToAcquire,
	uint32_t Option1,
	uint32_t Option2,
	uint32_t Option3,
	uint32_t Option4
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the transducer auto refresh acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <p>@param[in] <b><VAR>TransducerSelection:</VAR></b> Transducer type selection</p>
* <p>@param[in] <b><VAR>ChannelMask:</VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel)</p>
* <p>@param[in] <b><VAR>AverageMode:</VAR></b> Set the average mode : \n
*	<ul>
*                              <li> 0: not used \n
*                              <li> 1: average per Sequence \n
*                              <li> 2: average per channel
*   </ul></p>
* <p>@param[in] <b>AverageValue:</b> Set the average value (only used, when average is used) \n
*	<ul>
*                             <li> 0: average not used \n
*                             <li> max value: 255
*   </ul></p>
* <p>@param[in] <b>DivisionFactor:</b> Division factor (min : 5, max 255)</p>
* <p>@param[in]  <b>TriggerAction:</b> Trigger action : \n
*				 <ul><li><b> <VAR>Hardware Trigger Start D0 - D7 </VAR> </b>\n
*				 	Bit 3,2,1,0 : Define the trigger mode \n
*				 	<ul><li> 0000 : Trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*					<ul>
*				 	Bit 7,6 : define the active front (Only if hardware trigger selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger selected) \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Synchronisation Trigger Start : D8-D15 </VAR> </b>\n
*				 	Bit 11,10,9,8 : Define the trigger mode \n
*				 	<ul><li> 0000 : trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Hardware Trigger Stop D16 - D19 </VAR> </b>\n
* 					The hardware trigger stop can only be activated when :\n
* 					<ul><li> The hardware trigger start is not used.\n
*  					<li> The hardware trigger start is used in one shot mode.\n</ul></ul><br>
*
* 					<ul>The stop of the acquisition is really do at the end of a sequence acquisition(to avoid that the acquisition is stop in the middle of a sequence).\n </ul><br>
*                   <ul>
*				 	Bit 16 : Define the trigger stop is enable or not \n<ul>
*				 	<li> 0 : Stop trigger disabled \n
*				 	<li> 1 : Stop trigger enabled.\n</ul></ul><br>
*
*                   <ul>
*				 	Bit 18,17 : define the active front (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger stop selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger stop selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger stop selected) \n</ul></ul><br>
*
*                   <ul>
*				 	Bit 19 : define if the hardware trigger stop use the ulHardwareTriggerCount (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 0 : ulHardwareTriggerCount not used : First hardware trigger stop will stop the acquisition \n
*				 	<li> 1 : ulHardwareTriggerCount is used : The ulHardwareTriggerCount hardware trigger will stop the acquisition\n</ul></ul><br>
*
*					</p>
*
* <p>@param[in] <b>HardwareTriggerCount:</b> Define the number of trigger events before the action occur \n<ul>
*										<li>0 or 1: all trigger event start the action \n
*										<li>max value: 65535</ul></p>
* <p>@param[in] <b>HardwareTriggerFilterTime:</b> filter time for the hardware trigger \n<ul>
*										<li>in multiplier from 250 ns step \n
*										<li>max value: 65535</ul></p>
* <p>@param[in] <b>ByTriggerNbrOfSeqToAcquire:</b> define the number of sequences to acquire by each trigger event</p>
* <p>@param[in] <b>Option1:</b> Data format option \n<ul>
*                        <li>D0: Time stamp information \n<ul>
*                        <li> 0: no time stamp information \n
*                        <li> 1: time stamp information \n</ul><br></ul>
*
*                        <ul><li>D1: Data format \n<ul>
*                        <li> 0: Digital value \n
*                        <li> 1: Analog value (in mm) \n</ul></ul><br>
*
*                        <ul><li>D2: invert value \n<ul>
*                        <li> 0: don't invert the channel value \n
*                        <li> 1: invert the channel value (-2 mm -> + 2mm) \n</ul></ul></p>
*
* <p>@param[in] <b>Option2:</b> Reserved</p>
* <p>@param[in] <b>Option3:</b> Reserved</p>
* <p>@param[in] <b>Option4:</b> Reserved</p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                            <li>  0: success \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Transducer selection error \n
*                            <li> -3: Channel mask error : can not be null \n
*                            <li> -4: Channel mask error \n
*                            <li> -5: Average mode error \n
*                            <li> -6: Average value error \n
*                            <li> -7: Division factor error \n
*                            <li> -8: Incorrect value for Hardware Trigger Mode \n
*                            <li> -9: Incorrect value for Hardware Trigger front \n
*                            <li> -10: Incorrect value for Synchro Trigger Mode \n
*                            <li> -11: Incorrect value for Hardware Trigger count \n
*                            <li> -12: Incorrect value for Hardware Trigger filter time \n
*                            <li> -13: Incorrect value for "trigger number of sequences to acquire"\n
*                            <li> -14: Wrong data format parameter (ulOption1) \n
* 							 <li> -15: A value for Hardware Trigger front was defined but Hardware Trigger Mode is not set \n
* 							 <li> -16: Cannot use both triggers at the same time \n
*						     <li> -17: Incorrect value for the hardware trigger stop front \n
*                            <li> -18: Hardware trigger stop can not be used by this configuration of hardware trigger start\n
*
*                            <li> -100: TransducerInit kernel function error \n
*                            <li> -101: InitConvertTimeDivisionFactor kernel function error \n
*                            <li> -102: SetAutoRefreshAverageValue kernel function error \n
*                            <li> -103: InitDigitalInputFilter kernel function error \n
*                            <li> -104: InitEnableDisableHardwareTrigger kernel function error \n
*                            <li> -105: SynchroTrigger Init/Enable/Disable kernel function error \n
*                            <li> -106: SetTriggerSequenceCount kernel function error \n
*                            <li> -107: StartAutoRefresh kernel function error \n
*
*</ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerInitAndStartAutoRefreshEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerSelection;
	uint32_t ChannelMask;
	uint32_t AverageMode;
	uint32_t AverageValue;
	uint32_t DivisionFactor;
	uint32_t TriggerAction;
	uint16_t HardwareTriggerCount;
	uint16_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerInitAndStartAutoRefreshEx(modbus,TransducerSelection,ChannelMask,AverageMode,AverageValue,DivisionFactor,TriggerAction,HardwareTriggerCount,HardwareTriggerFilterTime,ByTriggerNbrOfSeqToAcquire,Option1,Option2,Option3,Option4,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerInitAndStartAutoRefreshEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerInitAndStartAutoRefreshEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerInitAndStartAutoRefreshEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerInitAndStartAutoRefreshEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerInitAndStartAutoRefreshEx(struct modbus * modbus,
	uint32_t TransducerSelection,
	uint32_t ChannelMask,
	uint32_t AverageMode,
	uint32_t AverageValue,
	uint32_t DivisionFactor,
	uint32_t TriggerAction,
	uint16_t HardwareTriggerCount,
	uint16_t HardwareTriggerFilterTime,
	uint32_t ByTriggerNbrOfSeqToAcquire,
	uint32_t Option1,
	uint32_t Option2,
	uint32_t Option3,
	uint32_t Option4
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the transducer auto refresh acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>Dummy:</VAR></b> Is not used</p></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  means an system error occured \n
* <li> -100: StopAutoRefresh kernel function error\n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerStopAndReleaseAutoRefresh(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerStopAndReleaseAutoRefresh(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerStopAndReleaseAutoRefresh");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerStopAndReleaseAutoRefresh\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerStopAndReleaseAutoRefresh()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerStopAndReleaseAutoRefresh OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerStopAndReleaseAutoRefresh(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the transducer auto refresh acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>Dummy:</VAR></b> Is not used</p></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  means an system error occured \n
* <li> -100: StopAutoRefresh kernel function error\n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerStopAndReleaseAutoRefreshEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerStopAndReleaseAutoRefreshEx(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerStopAndReleaseAutoRefreshEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerStopAndReleaseAutoRefreshEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerStopAndReleaseAutoRefreshEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerStopAndReleaseAutoRefreshEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerStopAndReleaseAutoRefreshEx(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the transducer sequence acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <p>@param[in] <b>TransducerSelection :</b> Transducer type selection</p>
* <p>@param[in] <b>NbrOfChannel :</b> Number of channel in the sequence</p>
* <p>@param[in] <b>ChannelList :</b> List of the channel index (0 to MaxChannel-1) who compose the sequence</p>
* <p>@param[in] <b>DivisionFactor :</b>  Division factor (min: 5, max: 255)</p>
* <p>@param[in] <b>NbrOfSequence :</b> Number of sequence to acquire :\n
*	<ul>
*                               <li> 0 : continuous mode \n
*                               <li> > 0 : number of sequence
*
*   </ul></p>
* <p>@param[in] <b>NbrMaxSequenceToTransfer :</b> This parameter defined the minimal number of sequences to acquire between each send of data by the modul.\n
*	<ul>
*                                         Warning : They are two possibilities that the number of sequences sent doesn't reach the minimal number:\n
*                                         <li> By the end of the acquisition.\n
*                                         <li> If the memory capicity is not big enough.
*
*   </ul></p>
* <p>@param[in] <b>DelayMode :</b> Delay Mode : \n
*	<ul>
*                            <li> ADDIDATA_DELAY_NOT_USED	0 : Delay is not used. \n
*                            <li> ADDIDATA_DELAY_MODE1_USED	1 : The delay time defines the time between 2 sequence beginnings.\n
*                            <li> ADDIDATA_DELAY_MODE2_USED  2 : The delay time defines the time between the end of a sequence until the beginning of the next sequence.
*   </ul></p>
* <p>@param[in] <b>DelayTimeUnit :</b> Selection of the delay time unit \n
*	<ul>
*                               <li> 0: ms   \n
*                               <li> 1: s
*   </ul></p>
* <p>@param[in] <b>DelayValue :</b> Delay Value (max value: 65535) </p>
* <p>@param[in] <b>TriggerAction :</b>  Trigger action : \n
*				 <ul><li><b> <VAR>Hardware Trigger Start D0 - D7 </VAR> </b>\n
*				 	Bit 3,2,1,0 : Define the trigger mode \n
*				 	<ul><li> 0000 : Trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*					<ul>
*				 	Bit 7,6 : define the active front (Only if hardware trigger selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger selected) \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Synchronisation Trigger Start : D8-D15 </VAR> </b>\n
*				 	Bit 11,10,9,8 : Define the trigger mode \n
*				 	<ul><li> 0000 : trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Hardware Trigger Stop D16 - D19 </VAR> </b>\n
* 					The hardware trigger stop can only be activated when :\n
* 					<ul><li> The hardware trigger start is not used.\n
*  					<li> The hardware trigger start is used in one shot mode.\n</ul></ul><br>
*
* 					<ul>The stop of the acquisition is really do at the end of a sequence acquisition(to avoid that the acquisition is stop in the middle of a sequence).\n </ul><br>
*                   <ul>
*				 	Bit 16 : Define the trigger stop is enable or not \n<ul>
*				 	<li> 0 : Stop trigger disabled \n
*				 	<li> 1 : Stop trigger enabled.\n</ul></ul><br>
*
*                   <ul>
*				 	Bit 18,17 : define the active front (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger stop selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger stop selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger stop selected) \n</ul></ul><br>
*
*                   <ul>
*				 	Bit 19 : define if the hardware trigger stop use the ulHardwareTriggerCount (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 0 : ulHardwareTriggerCount not used : First hardware trigger stop will stop the acquisition \n
*				 	<li> 1 : ulHardwareTriggerCount is used : The ulHardwareTriggerCount hardware trigger will stop the acquisition\n</ul></ul><br>
*
*					</p>
*
* <p>@param[in] <b>HardwareTriggerCount :</b> Define the number of trigger events before the trigger action occur \n
*	<ul>
*                                      <li> 0 or 1 : all trigger event start the trigger action \n
*                                      <li> max value : 65535 \n
*   </ul></p>
* <p>@param[in] <b>HardwareTriggerFilterTime :</b> Filter time for the hardware trigger (= multiplier from 250 ns step) \n
*	<ul>
*                                          <li> max value : 65535
*   </ul></p>
* <p>@param[in] <b>ByTriggerNbrOfSeqToAcquire :</b> define the number of sequences to acquire by each trigger event</p>
* <p>@param[in] <b>Option1 :</b> Data format option \n<ul>
*                        <li>D0 : Time stamp information \n<ul>
*                        <li> 0 : No time stamp information \n
*                        <li> 1 : Time stamp information \n</ul><br></ul>
*
*                        <ul><li>D1 : Sequence counter information \n<ul>
*                        <li> 0 : No sequence counter information \n
*                        <li> 1 : Sequence counter information \n</ul></ul><br>
*
*                        <ul><li>D2 : Data format \n<ul>
*                        <li> 0 : Digital value \n
*                        <li> 1 : Analog value (in mm) \n</ul></ul><br>
*
*                        <ul><li>D3 : invert value \n<ul>
*                        <li> 0 : Don't invert the channel value \n
*                        <li> 1 : Invert the channel value (-2 mm -> + 2mm) \n</ul></ul><br>
*
*                        <ul><li>D4 : receive a relative Time Stamp (first acquisition => time stamp=0) instead of absolute time stamp \n<ul>
*                        <li> 0 : No relative time stamp information \n
*                        <li> 1 : Relative time stamp information \n</ul></ul></p>
* <p>@param[in] <b>Option2 :</b> Reserved</p>
* <p>@param[in] <b>Option3 :</b> Reserved</p>
* <p>@param[in] <b>Option4 :</b> Reserved</p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li> 0 : success \n
*                             <li> -1: means an system error occured \n
*                             <li> -2: Tranducer selection error \n
*                             <li> -3: Number of channel error \n
*                             <li> -4: Channel array selection error \n
*                             <li> -5: Division factor error \n
*                             <li> -6: Incorrect value for Hardware Trigger Mode \n
*                             <li> -7: Incorrect value for Hardware Trigger Front \n
*                             <li> -8: Incorrect value for Synchro Trigger Mode \n
*                             <li> -9: Incorrect value for Hardware Trigger Count \n
*                             <li> -10: Incorrect value for Hardware Trigger filter time \n
*                             <li> -11: Incorrect value for "trigger number of sequences to acquire" \n
*                             <li> -12: Delay Mode selection error \n
*                             <li> -13: Delay time unit selection error \n
*                             <li> -14: Delay value
*                             <li> -15: Wrong data format parameter (ulOption1) \n
*                             <li> -16: A value for Hardware Trigger front was defined but Hardware Trigger Mode is not set \n
*                             <li> -17: Cannot use both triggers at the same time \n
*						      <li> -18: Incorrect value for the hardware trigger stop front \n
*                             <li> -19: Hardware trigger stop can not be used by this configuration of hardware trigger start\n
*
*                             <li> -100: TransducerInit kernel function error \n
*                             <li> -101: InitConvertTimeDivisionFactor kernel function error \n
*                             <li> -102: InitEnableDisableSequenceDelay kernel function error \n
*                             <li> -103: InitDigitalInputFilter kernel function error \n
*                             <li> -104: InitEnableDisableHardwareTrigger kernel function error \n
*                             <li> -105: InitEnableSynchroTrigger kernel function error \n
*                             <li> -106: DisableSynchroTrigger kernel function error \n
*                             <li> -107: SetTriggerSequenceCount kernel function error \n
*                             <li> -108: InitSequence kernel function error \n
*                             <li> -109: StartStopSequence kernel function error \n
*</ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerInitAndStartSequence(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerSelection;
	uint32_t NbrOfChannel;
	uint32_t ChannelList[16];
	uint32_t DivisionFactor;
	uint32_t NbrOfSequence;
	uint32_t NbrMaxSequenceToTransfer;
	uint32_t DelayMode;
	uint32_t DelayTimeUnit;
	uint32_t DelayValue;
	uint32_t TriggerAction;
	uint32_t HardwareTriggerCount;
	uint32_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerInitAndStartSequence(modbus,TransducerSelection,NbrOfChannel,ChannelList,DivisionFactor,NbrOfSequence,NbrMaxSequenceToTransfer,DelayMode,DelayTimeUnit,DelayValue,TriggerAction,HardwareTriggerCount,HardwareTriggerFilterTime,ByTriggerNbrOfSeqToAcquire,Option1,Option2,Option3,Option4,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerInitAndStartSequence");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerInitAndStartSequence\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerInitAndStartSequence()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerInitAndStartSequence OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerInitAndStartSequence(struct modbus * modbus,
	uint32_t TransducerSelection,
	uint32_t NbrOfChannel,
	uint32_t ChannelList[16],
	uint32_t DivisionFactor,
	uint32_t NbrOfSequence,
	uint32_t NbrMaxSequenceToTransfer,
	uint32_t DelayMode,
	uint32_t DelayTimeUnit,
	uint32_t DelayValue,
	uint32_t TriggerAction,
	uint32_t HardwareTriggerCount,
	uint32_t HardwareTriggerFilterTime,
	uint32_t ByTriggerNbrOfSeqToAcquire,
	uint32_t Option1,
	uint32_t Option2,
	uint32_t Option3,
	uint32_t Option4
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise and start the transducer sequence acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
*
* <p>@param[in] <b>TransducerSelection :</b> Transducer type selection</p>
* <p>@param[in] <b>NbrOfChannel :</b> Number of channel in the sequence</p>
* <p>@param[in] <b>ChannelList :</b> List of the channel index (0 to MaxChannel-1) who compose the sequence</p>
* <p>@param[in] <b>DivisionFactor :</b>  Division factor (min: 5, max: 255)</p>
* <p>@param[in] <b>NbrOfSequence :</b> Number of sequence to acquire :\n
*	<ul>
*                               <li> 0 : continuous mode \n
*                               <li> > 0 : number of sequence
*
*   </ul></p>
* <p>@param[in] <b>NbrMaxSequenceToTransfer :</b> This parameter defined the minimal number of sequences to acquire between each send of data by the modul.\n
*	<ul>
*                                         Warning : They are two possibilities that the number of sequences sent doesn't reach the minimal number:\n
*                                         <li> By the end of the acquisition.\n
*                                         <li> If the memory capicity is not big enough.
*
*   </ul></p>
* <p>@param[in] <b>DelayMode :</b> Delay Mode : \n
*	<ul>
*                            <li> ADDIDATA_DELAY_NOT_USED	0 : Delay is not used. \n
*                            <li> ADDIDATA_DELAY_MODE1_USED	1 : The delay time defines the time between 2 sequence beginnings.\n
*                            <li> ADDIDATA_DELAY_MODE2_USED  2 : The delay time defines the time between the end of a sequence until the beginning of the next sequence.
*   </ul></p>
* <p>@param[in] <b>DelayTimeUnit :</b> Selection of the delay time unit \n
*	<ul>
*                               <li> 0: ms   \n
*                               <li> 1: s
*   </ul></p>
* <p>@param[in] <b>DelayValue :</b> Delay Value (max value: 65535) </p>
* <p>@param[in] <b>TriggerAction :</b>  Trigger action : \n
*				 <ul><li><b> <VAR>Hardware Trigger Start D0 - D7 </VAR> </b>\n
*				 	Bit 3,2,1,0 : Define the trigger mode \n
*				 	<ul><li> 0000 : Trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*					<ul>
*				 	Bit 7,6 : define the active front (Only if hardware trigger selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger selected) \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Synchronisation Trigger Start : D8-D15 </VAR> </b>\n
*				 	Bit 11,10,9,8 : Define the trigger mode \n
*				 	<ul><li> 0000 : trigger disabled \n
*				 	<li> 0001 : One shot trigger : After the software start, the module is waiting for a trigger signal to start the acquisition. After this the trigger signal is ignored.\n
*				 	<li> 0010 : Sequence trigger : After the software start the module is waiting for the trigger signal and acquires x sequences (also adjustable) and then wait again. \n</ul></ul><br>
*
*				 <ul><li><b> <VAR>Hardware Trigger Stop D16 - D19 </VAR> </b>\n
* 					The hardware trigger stop can only be activated when :\n
* 					<ul><li> The hardware trigger start is not used.\n
*  					<li> The hardware trigger start is used in one shot mode.\n</ul></ul><br>
*
* 					<ul>The stop of the acquisition is really do at the end of a sequence acquisition(to avoid that the acquisition is stop in the middle of a sequence).\n </ul><br>
*                   <ul>
*				 	Bit 16 : Define the trigger stop is enable or not \n<ul>
*				 	<li> 0 : Stop trigger disabled \n
*				 	<li> 1 : Stop trigger enabled.\n</ul></ul><br>
*
*                   <ul>
*				 	Bit 18,17 : define the active front (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 01 : rising front (Only if hardware trigger stop selected) \n
*				 	<li> 10 : falling front (Only if hardware trigger stop selected) \n
*				 	<li> 11 : Both front (Only if hardware trigger stop selected) \n</ul></ul><br>
*
*                   <ul>
*				 	Bit 19 : define if the hardware trigger stop use the ulHardwareTriggerCount (Only if hardware trigger stop selected) \n<ul>
*				 	<li> 0 : ulHardwareTriggerCount not used : First hardware trigger stop will stop the acquisition \n
*				 	<li> 1 : ulHardwareTriggerCount is used : The ulHardwareTriggerCount hardware trigger will stop the acquisition\n</ul></ul><br>
*
*					</p>
*
* <p>@param[in] <b>HardwareTriggerCount :</b> Define the number of trigger events before the trigger action occur \n
*	<ul>
*                                      <li> 0 or 1 : all trigger event start the trigger action \n
*                                      <li> max value : 65535 \n
*   </ul></p>
* <p>@param[in] <b>HardwareTriggerFilterTime :</b> Filter time for the hardware trigger (= multiplier from 250 ns step) \n
*	<ul>
*                                          <li> max value : 65535
*   </ul></p>
* <p>@param[in] <b>ByTriggerNbrOfSeqToAcquire :</b> define the number of sequences to acquire by each trigger event</p>
* <p>@param[in] <b>Option1 :</b> Data format option \n<ul>
*                        <li>D0 : Time stamp information \n<ul>
*                        <li> 0 : No time stamp information \n
*                        <li> 1 : Time stamp information \n</ul><br></ul>
*
*                        <ul><li>D1 : Sequence counter information \n<ul>
*                        <li> 0 : No sequence counter information \n
*                        <li> 1 : Sequence counter information \n</ul></ul><br>
*
*                        <ul><li>D2 : Data format \n<ul>
*                        <li> 0 : Digital value \n
*                        <li> 1 : Analog value (in mm) \n</ul></ul><br>
*
*                        <ul><li>D3 : invert value \n<ul>
*                        <li> 0 : Don't invert the channel value \n
*                        <li> 1 : Invert the channel value (-2 mm -> + 2mm) \n</ul></ul><br>
*
*                        <ul><li>D4 : receive a relative Time Stamp (first acquisition => time stamp=0) instead of absolute time stamp \n<ul>
*                        <li> 0 : No relative time stamp information \n
*                        <li> 1 : Relative time stamp information \n</ul></ul></p>
* <p>@param[in] <b>Option2 :</b> Reserved</p>
* <p>@param[in] <b>Option3 :</b> Reserved</p>
* <p>@param[in] <b>Option4 :</b> Reserved</p>
* </ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li> 0 : success \n
*                             <li> -1: means an system error occured \n
*                             <li> -2: Tranducer selection error \n
*                             <li> -3: Number of channel error \n
*                             <li> -4: Channel array selection error \n
*                             <li> -5: Division factor error \n
*                             <li> -6: Incorrect value for Hardware Trigger Mode \n
*                             <li> -7: Incorrect value for Hardware Trigger Front \n
*                             <li> -8: Incorrect value for Synchro Trigger Mode \n
*                             <li> -9: Incorrect value for Hardware Trigger Count \n
*                             <li> -10: Incorrect value for Hardware Trigger filter time \n
*                             <li> -11: Incorrect value for "trigger number of sequences to acquire" \n
*                             <li> -12: Delay Mode selection error \n
*                             <li> -13: Delay time unit selection error \n
*                             <li> -14: Delay value
*                             <li> -15: Wrong data format parameter (ulOption1) \n
*                             <li> -16: A value for Hardware Trigger front was defined but Hardware Trigger Mode is not set \n
*                             <li> -17: Cannot use both triggers at the same time \n
*						      <li> -18: Incorrect value for the hardware trigger stop front \n
*                             <li> -19: Hardware trigger stop can not be used by this configuration of hardware trigger start\n
*
*                             <li> -100: TransducerInit kernel function error \n
*                             <li> -101: InitConvertTimeDivisionFactor kernel function error \n
*                             <li> -102: InitEnableDisableSequenceDelay kernel function error \n
*                             <li> -103: InitDigitalInputFilter kernel function error \n
*                             <li> -104: InitEnableDisableHardwareTrigger kernel function error \n
*                             <li> -105: InitEnableSynchroTrigger kernel function error \n
*                             <li> -106: DisableSynchroTrigger kernel function error \n
*                             <li> -107: SetTriggerSequenceCount kernel function error \n
*                             <li> -108: InitSequence kernel function error \n
*                             <li> -109: StartStopSequence kernel function error \n
*</ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerInitAndStartSequenceEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerSelection;
	uint32_t NbrOfChannel;
	uint32_t ChannelList[16];
	uint32_t DivisionFactor;
	uint32_t NbrOfSequence;
	uint32_t NbrMaxSequenceToTransfer;
	uint32_t DelayMode;
	uint32_t DelayTimeUnit;
	uint32_t DelayValue;
	uint32_t TriggerAction;
	uint32_t HardwareTriggerCount;
	uint32_t HardwareTriggerFilterTime;
	uint32_t ByTriggerNbrOfSeqToAcquire;
	uint32_t Option1;
	uint32_t Option2;
	uint32_t Option3;
	uint32_t Option4;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerInitAndStartSequenceEx(modbus,TransducerSelection,NbrOfChannel,ChannelList,DivisionFactor,NbrOfSequence,NbrMaxSequenceToTransfer,DelayMode,DelayTimeUnit,DelayValue,TriggerAction,HardwareTriggerCount,HardwareTriggerFilterTime,ByTriggerNbrOfSeqToAcquire,Option1,Option2,Option3,Option4,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerInitAndStartSequenceEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerInitAndStartSequenceEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerInitAndStartSequenceEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerInitAndStartSequenceEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerInitAndStartSequenceEx(struct modbus * modbus,
	uint32_t TransducerSelection,
	uint32_t NbrOfChannel,
	uint32_t ChannelList[16],
	uint32_t DivisionFactor,
	uint32_t NbrOfSequence,
	uint32_t NbrMaxSequenceToTransfer,
	uint32_t DelayMode,
	uint32_t DelayTimeUnit,
	uint32_t DelayValue,
	uint32_t TriggerAction,
	uint32_t HardwareTriggerCount,
	uint32_t HardwareTriggerFilterTime,
	uint32_t ByTriggerNbrOfSeqToAcquire,
	uint32_t Option1,
	uint32_t Option2,
	uint32_t Option3,
	uint32_t Option4
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the transducer sequence acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>Dummy:</VAR></b> Is not used</p></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  means an system error occured \n
* <li> -100: StartStopSequence kernel function error\n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerStopAndReleaseSequence(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerStopAndReleaseSequence(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerStopAndReleaseSequence");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerStopAndReleaseSequence\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerStopAndReleaseSequence()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerStopAndReleaseSequence OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerStopAndReleaseSequence(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the transducer sequence acquisition mode</p>
*
* <p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR>Dummy:</VAR></b> Is not used</p></ul>
*
* <p><b> Returns:</b></p><ul>
*
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  means an system error occured \n
* <li> -100: StartStopSequence kernel function error\n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerStopAndReleaseSequenceEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerStopAndReleaseSequenceEx(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerStopAndReleaseSequenceEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerStopAndReleaseSequenceEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerStopAndReleaseSequenceEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerStopAndReleaseSequenceEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerStopAndReleaseSequenceEx(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Change the active transducer database cursor</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>TransducerDatabaseCursor:</VAR></b> New cursor value. This is an integer from 0 .. (NumberOfTransducerTypes-1) </p></ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__SetTransducerDatabaseCursor(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerDatabaseCursor;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__SetTransducerDatabaseCursor(modbus,TransducerDatabaseCursor,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__SetTransducerDatabaseCursor");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__SetTransducerDatabaseCursor\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__SetTransducerDatabaseCursor()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__SetTransducerDatabaseCursor OK\n");
	return 0;
}

*/

int modbus_call_MX370x__SetTransducerDatabaseCursor(struct modbus * modbus,
	uint32_t TransducerDatabaseCursor
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Change the active transducer database cursor</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>TransducerDatabaseCursor:</VAR></b> New cursor value. This is an integer from 0 .. (NumberOfTransducerTypes-1) </p></ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* </ul></ul>
*/
	
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__SetTransducerDatabaseCursorEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t TransducerDatabaseCursor;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__SetTransducerDatabaseCursorEx(modbus,TransducerDatabaseCursor,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__SetTransducerDatabaseCursorEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__SetTransducerDatabaseCursorEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__SetTransducerDatabaseCursorEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__SetTransducerDatabaseCursorEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__SetTransducerDatabaseCursorEx(struct modbus * modbus,
	uint32_t TransducerDatabaseCursor
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Set the offset for each transducer.</p>
*
* <p> <b> Set / Reset </b> an offset on transducer channels.\n </p>
* <p>
*   <ul>
*       <li> This function permits to set an offset (reference point) to the measured value. \n
*       <li> To disable (reset) a channel offset, set the corresponding channel value to 0.0.\n 
*   </ul>
* </p>
* <p> <b> Example: </b> To set a reference point to a transducer in a particular position: \n </p>
* <p>
*   <ul>
*     <li> Reset the offset by setting all channel offset to 0 (pdOffsetArray).
*     <li> Run a sequence with the transducer at the position you want to be 0 (reference point). Save the acquired values to put them into pdOffsetArray.
*     <li> Stop the acquisition.
*     <li> Run MX370x__TransducerSetOffset function to set the offset with the pdOffsetArray previously saved.
*     <li> In the next sequence, position will be 0. 
*   </ul>
* </p>
*
* <p> For more information see SetOffset sample. </p>
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>fOffsetArrayPointer:</VAR></b> table pointer with each offsets for transducers. </p></ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* <li> -2:  driver status error, acquisition is running \n
* <li> -100: transducerSetOffset kernel function error \n
* </ul></ul>
*/
    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerSetOffset(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	float fOffsetArrayPointer[16];

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerSetOffset(modbus,fOffsetArrayPointer,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerSetOffset");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerSetOffset\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerSetOffset()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerSetOffset OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerSetOffset(struct modbus * modbus,
	float fOffsetArrayPointer[16]
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Set the offset for each transducer.</p>
*
* <p> <b> Set / Reset </b> an offset on transducer channels.\n </p>
* <p>
*   <ul>
*       <li> This function permits to set an offset (reference point) to the measured value. \n
*       <li> To disable (reset) a channel offset, set the corresponding channel value to 0.0.\n 
*   </ul>
* </p>
* <p> <b> Example: </b> To set a reference point to a transducer in a particular position: \n </p>
* <p>
*   <ul>
*     <li> Reset the offset by setting all channel offset to 0 (pdOffsetArray).
*     <li> Run a sequence with the transducer at the position you want to be 0 (reference point). Save the acquired values to put them into pdOffsetArray.
*     <li> Stop the acquisition.
*     <li> Run MX370x__TransducerSetOffset function to set the offset with the pdOffsetArray previously saved.
*     <li> In the next sequence, position will be 0. 
*   </ul>
* </p>
*
* <p> For more information see SetOffset sample. </p>
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>fOffsetArrayPointer:</VAR></b> table pointer with each offsets for transducers. </p></ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li> 0: success \n
* <li> -1:  otherwise : internal error \n
* <li> -2:  driver status error, acquisition is running \n
* <li> -100: transducerSetOffset kernel function error \n
* </ul></ul>
*/
    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MX370x__TransducerSetOffsetEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	float fOffsetArrayPointer[16];

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MX370x__TransducerSetOffsetEx(modbus,fOffsetArrayPointer,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MX370x__TransducerSetOffsetEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MX370x__TransducerSetOffsetEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MX370x__TransducerSetOffsetEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MX370x__TransducerSetOffsetEx OK\n");
	return 0;
}

*/

int modbus_call_MX370x__TransducerSetOffsetEx(struct modbus * modbus,
	float fOffsetArrayPointer[16]
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE370X_CLIENT_DEFINITION_H_


