/*
  +--------------------------------------------------------------------------------------+
  | (C) ADDI-DATA GmbH          Dieselstrae 3       D-77833 Ottersweier                 |
  +--------------------------------------------------------------------------------------+
  | Tel : +49 (0) 7223/9493-0     | email    : info@addi-data.com                        |
  | Fax : +49 (0) 7223/9493-92    | Internet : http://www.addi-data.com                  |
  +-------------------------------+------------------------------------------------------+
  | Project     : API  ADDI-DATA  |     Compiler   : BORLANDC/MICROSOFT C                |
  | Module name : DEFINE.H        |     Version    : 3.1     / 6.0                       |
  |                               |                                                      |
  |                               |                                                      |
  +-------------------------------+------------------------------------------------------+
  | Author : Weber S.                      Date :14/12/1999                              |
  +--------------------------------------------------------------------------------------+
  | Description   : Header file for the ADDI-DATA error funtionality                     |
  |                 driver                                                               |
  +--------------------------------------------------------------------------------------+
  |                             UPDATES                                                  |
  +----------+-----------+---------------------------------------------------------------+
  |   Date   |   Author  |          Description of updates                               |
  +----------+-----------+---------------------------------------------------------------+
  
  +----------+-----------+---------------------------------------------------------------+
  */



#ifndef ADDIDATA_DEFINE_HEADER
   #define ADDIDATA_DEFINE_HEADER

   /**************************************/
   /* Test if ADDI-DATA type declation ? */
   /**************************************/

   #ifndef ADDI_DATA_TYPE_DECLARATION

      #define ADDI_DATA_TYPE_DECLARATION

      #ifndef MAXPATH
	 #define MAXPATH 125
      #endif

      /********************************/
      /* Test if Dos or Windows 3.11 ? /
      /********************************/

      #ifndef _WIN32

         /*********************************************/
	 /* Type declaration for Dos and Windows 3.11 */
	 /*********************************************/

	 #if defined (__cplusplus)
	    #define __CPPARGS ...
	 #elif defined (__BORLANDC__)
	    #define __CPPARGS VOID
	 #else  // #if defined (__cplusplus)
	    #define __CPPARGS
	 #endif // #if defined (__cplusplus)

	 #define KS_Error int

	 #if defined (_Windows) | defined (_WINDOWS)

	    /*********************************/
	    /* Windows 3.11 type declaration */
	    /*********************************/

	    /******************************/
	    /* Include the windows.h file */
	    /******************************/

	    #include <windows.h>

	    typedef char            CHAR;
	    typedef int             INT;
	    typedef unsigned int    UINT;
	    typedef unsigned long   ULONG;
	    typedef void            VOID;
	    typedef double          DOUBLE;
	    typedef unsigned char * PBYTE;
	    typedef char          * PCHAR;
	    typedef unsigned int  * PUINT;
	    typedef long          * PLONG;
	    typedef unsigned long * PULONG;
	    typedef void          * PVOID;
	    typedef double        * PDOUBLE;
             

	    #ifdef __cplusplus
	       #define _INT_ extern "C"  INT  far _stdcall
 	       #define _BOOL_ extern "C" BOOL far _stdcall
	       #define _VOID_ extern "C" VOID far _stdcall
	       // 06/11/00 CG 0800/0200 -> 0900/0210
	       #define _BYTE_ extern "C" BYTE far _stdcall
	    #else  // #ifdef __cplusplus
	       #define _INT_  INT  far _stdcall
 	       #define _BOOL_ BOOL far _stdcall
	       #define _VOID_ VOID far _stdcall
	       // 06/11/00 CG 0800/0200 -> 0900/0210
	       #define _BYTE_ BYTE far _stdcall
	    #endif // #ifdef __cplusplus

	 #else // defined (_Windows) | defined (_WINDOWS)

	    #define TRUE  1
	    #define FALSE 0
	    #define _loadds
	    #define HANDLE WORD

	    /***********************/
	    /* Dos type decaration */
	    /***********************/

	    #if defined   (__TPASCAL__)
	       /**********************************/
	       /* Borland Pascal type decaration */
	       /**********************************/

	       typedef unsigned char   BOOL;
	       typedef unsigned char   BYTE;
	       typedef char            CHAR;
	       typedef int             INT;
	       typedef unsigned int    UINT;
	       typedef unsigned int    WORD;
	       typedef unsigned long   DWORD;
	       typedef long            LONG;
	       typedef unsigned long   ULONG;
	       typedef void            VOID;
	       typedef double          DOUBLE;
	       typedef unsigned char * PBOOL;
	       typedef unsigned char * PBYTE;
	       typedef char          * PCHAR;
	       typedef int           * PINT;
	       typedef unsigned int  * PUINT;
	       typedef unsigned int  * PWORD;
	       typedef unsigned long * PDWORD;
	       typedef long          * PLONG;
	       typedef unsigned long * PULONG;
	       typedef void          * PVOID;
	       typedef double        * PDOUBLE;

	       typedef INT  _INT_
	       typedef BOOL _BOOL_
	       typedef VOID _VOID_
      	       // 06/11/00 CG 0800/0200 -> 0900/0210
               typedef BYTE _BYTE_
	       #define WINAPI

	    #elif defined (__VBDOS__)
	       /********************************/
	       /* Microsoft VB type decaration */
	       /********************************/

	       typedef unsigned char        BOOL;
	       typedef unsigned char        BYTE;
	       typedef char                 CHAR;
	       typedef int                  INT;
	       typedef unsigned long        UINT;
	       typedef unsigned long        WORD;
	       typedef unsigned long        DWORD;
	       typedef long                 LONG;
	       typedef unsigned long        ULONG;
	       typedef void                 VOID;
	       typedef double               DOUBLE;
	       typedef unsigned char near * PBOOL;
	       typedef unsigned char near * PBYTE;
	       typedef char          near * PCHAR;
	       typedef int           near * PINT;
	       typedef unsigned long near * PUINT;
	       typedef unsigned long near * PWORD;
	       typedef unsigned long near * PDWORD;
	       typedef long          near * PLONG;
	       typedef unsigned long near * PULONG;
	       typedef void          near * PVOID;
	       typedef double        near * PDOUBLE;

	       typedef INT  _INT_
	       typedef BOOL _BOOL_
	       typedef VOID _VOID_
 	       // 06/11/00 CG 0800/0200 -> 0900/0210
	       typedef BYTE _BYTE_
               #define WINAPI
	    #else
	       /***********************************/
	       /* Borland/Microsoft C declaration */
	       /***********************************/

	       typedef unsigned char   BOOL;
	       typedef unsigned char   BYTE;
	       typedef char            CHAR;
	       typedef int             INT;
	       typedef unsigned int    UINT;
	       typedef unsigned int    WORD;
	       typedef unsigned long   DWORD;
	       typedef long            LONG;
	       typedef unsigned long   ULONG;
	       typedef void            VOID;
	       typedef double          DOUBLE;
	       typedef unsigned char * PBOOL;
	       typedef unsigned char * PBYTE;
	       typedef char          * PCHAR;
	       typedef int           * PINT;
	       typedef unsigned int  * PUINT;
	       typedef unsigned int  * PWORD;
	       typedef unsigned long * PDWORD;
	       typedef long          * PLONG;
	       typedef unsigned long * PULONG;
	       typedef void          * PVOID;
	       typedef double        * PDOUBLE;

	       #define _INT_  INT
	       #define _BOOL_ BOOL
	       #define _VOID_ VOID
       	       // 06/11/00 CG 0800/0200 -> 0900/0210
               #define _BYTE_ BYTE
	       #define WINAPI

	       /***********************/
	       /* Test if Microsoft C */
	       /***********************/

	       #ifndef __BORLANDC__
		  #define interrupt  _interrupt far
		  #define __CPPARGS
	       #endif
	    #endif
	 #endif // defined (_Windows) | defined (_WINDOWS)
      #else // #ifndef _WIN32

	 #define KS_Error Error
	 #include <windows.h>
// Begin nderung 11/09/01 |R. HILPERT | 0801/0215 -> 0901/02151                        
//	 #ifdef __BORLANDC__
	    #define DOUBLE   double
	    #define PDOUBLE *double
//	 #endif
// End nderung 11/09/01 |R. HILPERT | 0801/0215 -> 0901/02151                        


	 #define _loadds
	 #define __CPPARGS  PVOID pv_Args, PULONG pul_BoardInterruptCpt
	 #define interrupt
	 #define ADDIDATA_DEBUG
	 #define INT_      int
	 #define UINT_     unsigned int
	 #define BYTE_     unsigned char
	 #define CHAR_     char
	 #define LONG_     long
	 #define ULONG_    unsigned long
	 #define PINT_     int  *
	 #define PUINT_    unsigned int *
	 #define PUINT__   unsigned int *
	 #define PBYTE_    unsigned char *
	 #define PBYTE__   unsigned char *
	 #define PCHAR_    char  *
	 #define PLONG_    long *
	 #define PULONG_   unsigned long *
	 #define DLL_COMPILER_C          0
	 #define DLL_COMPILER_PASCAL     1
	 #define DLL_COMPILER_VB         2
	 #define DLL_LABVIEW             3
	 #define DLL_COMPILER_VB_5       4
	 
	 /**************************************/
	 /* Type declaration for Windows NT/9x */
	 /**************************************/

	 #ifdef __cplusplus
	    #define _INT_  extern "C" INT  WINAPI
	    #define _BOOL_ extern "C" BOOL WINAPI
	    #define _VOID_ extern "C" VOID WINAPI
            // 06/11/00 CG 0800/0200 -> 0900/0210
	    #define _BYTE_ extern "C" BYTE WINAPI
	 #else  // #ifdef __cplusplus
	    #define _INT_  INT  WINAPI
	    #define _BOOL_ BOOL WINAPI
	    #define _VOID_ VOID WINAPI
            // 06/11/00 CG 0800/0200 -> 0900/0210
	    #define _BYTE_ BYTE WINAPI

	 #endif // #ifdef __cplusplus

      #endif // #else #ifndef _WIN32
   #endif


   #define ADDIDATA_SOCKET_WSASTARTUP_ERROR		        -174
   #define ADDIDATA_SOCKET_GETHOSTBYNAME_ERROR                  -175
   #define ADDIDATA_CREATE_SOCKET_ERROR                         -176
   #define ADDIDATA_SOCKET_CONNECT_ERROR                        -177
   #define ADDIDATA_SOCKET_RCVBUF_ERROR                         -178

#endif
